| digiKam Developer Documentation Professional Photo Management with the Power of Open Source

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
ShowFoto::ShowfotoItemSortSettings Class Reference

## Public Types
enum | CategorizationMode { NoCategories , CategoryByFolder , CategoryByFormat }
enum | SortOrder { AscendingOrder = Qt::AscendingOrder , DescendingOrder = Qt::DescendingOrder , DefaultOrder }
enum | SortRole { SortByCreationDate , SortByFileName , SortByFileSize }

## Public Member Functions
int | compare (const ShowfotoItemInfo &left, const ShowfotoItemInfo &right) const
| Compares the showfotoItemInfos left and right.
int | compare (const ShowfotoItemInfo &left, const ShowfotoItemInfo &right, SortRole sortRole) const
int | compareCategories (const ShowfotoItemInfo &left, const ShowfotoItemInfo &right) const
| Compares the categories of left and right ShowfotoItemInfos.
bool | isCategorized () const
bool | lessThan (const QVariant &left, const QVariant &right) const
| Returns true if left QVariant is less than right.
bool | lessThan (const ShowfotoItemInfo &left, const ShowfotoItemInfo &right) const
| Returns true if left is less than right.
bool | operator== (const ShowfotoItemSortSettings &other) const
void | setCategorizationMode (CategorizationMode mode)
| — Categories ------------—
void | setCategorizationSortOrder (SortOrder order)
void | setSortOrder (SortOrder order)
void | setSortRole (SortRole role)
| — Showfoto Items Sorting ------------—

## Static Public Member Functions
template<typename T >
static int | compareByOrder (const T &a, const T &b, Qt::SortOrder sortOrder)
static int | compareByOrder (int compareResult, Qt::SortOrder sortOrder)
| Takes a typical result from a compare method (0 is equal, -1 is less than, 1 is greater than) and applies the given sort order to it.
template<typename T >
static int | compareValue (const T &a, const T &b)
| Returns the usual compare result of -1, 0, or 1 for lessThan, equals and greaterThan.
static Qt::SortOrder | defaultSortOrderForCategorizationMode (CategorizationMode mode)
static Qt::SortOrder | defaultSortOrderForSortRole (SortRole role)
template<typename T >
static bool | lessThanByOrder (const T &a, const T &b, Qt::SortOrder sortOrder)
| Returns a < b if sortOrder is Ascending, or b < a if order is descending.
static int | naturalCompare (const QString &a, const QString &b, Qt::SortOrder sortOrder, Qt::CaseSensitivity caseSensitive=Qt::CaseSensitive)
| Compares the two string by natural comparison and adheres to given sort order.

## Public Attributes
Qt::CaseSensitivity | categorizationCaseSensitivity = Qt::CaseSensitive
CategorizationMode | categorizationMode = NoCategories
SortOrder | categorizationSortOrder = DefaultOrder
Qt::SortOrder | currentCategorizationSortOrder = Qt::AscendingOrder
| Only Ascending or Descending, never be DefaultOrder.
Qt::SortOrder | currentSortOrder = Qt::AscendingOrder
Qt::CaseSensitivity | sortCaseSensitivity = Qt::CaseSensitive
SortOrder | sortOrder = DefaultOrder
SortRole | sortRole = SortByFileName

## Member Enumeration Documentation

## ◆ SortOrder

enum ShowFoto::ShowfotoItemSortSettings::SortOrder

Enumerator
DefaultOrder | sort order depends on the chosen sort role

## Member Function Documentation

## ◆ compare()

int ShowFoto::ShowfotoItemSortSettings::compare | ( | const ShowfotoItemInfo & | left,
|  | const ShowfotoItemInfo & | right
| ) |  | const

Return -1 if left is less than right, 1 if left is greater than right, and 0 if left equals right comparing the current sort role's value. Adheres to set sort role and sort order.

## ◆ compareCategories()

int ShowFoto::ShowfotoItemSortSettings::compareCategories | ( | const ShowfotoItemInfo & | left,
|  | const ShowfotoItemInfo & | right
| ) |  | const

It returns -1 if the left ShowfotoItemInfo is less than right, and 0 if both fall in the same category, and 1 if the left ShowfotoItemInfo is greater than right. Adheres to set categorization mode and current category sort order.

## ◆ lessThan() [1/2]

bool ShowFoto::ShowfotoItemSortSettings::lessThan | ( | const QVariant & | left,
|  | const QVariant & | right
| ) |  | const

Adheres to current sort role and sort order.

## ◆ lessThan() [2/2]

bool ShowFoto::ShowfotoItemSortSettings::lessThan | ( | const ShowfotoItemInfo & | left,
|  | const ShowfotoItemInfo & | right
| ) |  | const

Adheres to current sort role and sort order.